/*
**                    TMM v1.0 for Avisynth 2.5.x
**
**   TMM builds a motion-mask for TDeint, which TDeint uses via
**   its 'emask' parameter.  TMM can use fixed or per-pixel adaptive
**   motion thresholds, as well as any length static period.  It
**   checks backwards, across, and forwards when looking for motion.
**
**   Copyright (C) 2007 Kevin Stone
**
**   This program is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <windows.h>
#include "avisynth.h"
#include "PlanarFrame.h"

struct PFCC {
	PlanarFrame *pf[3];
	int n[2];
};

class createMM : public GenericVideoFilter
{
private:
	PFCC **frames;
	PlanarFrame *dstPF[2];
	int mtqL, mtqC, mthL, mthC;
	int *offnlut[3], *offplut[3], mlut[256];
	int ttype, nt, minthresh, maxthresh, cstr;
	void createMM::threshMask(PlanarFrame *src, PlanarFrame *dst);
	void createMM::motionMask(PlanarFrame *src1, PlanarFrame *msk1,
		PlanarFrame *src2, PlanarFrame *msk2, PlanarFrame *dst);
	void createMM::andMasks(PlanarFrame *dst, PlanarFrame *src1, 
		PlanarFrame *src2);
	void createMM::combineMasks(PlanarFrame *src, PlanarFrame *dst, 
		IScriptEnvironment *env);
	void createMM::resetFrames(PFCC **p, int start, int stop);
	int createMM::mapn(int n);

public:
	PVideoFrame __stdcall createMM::GetFrame(int n, IScriptEnvironment *env);
	createMM::createMM(PClip _child, int _ttype, int _mtqL, int _mthL, int _mtqC,
		int _mthC, int _nt, int _minthresh, int _maxthresh, int _cstr, 
		IScriptEnvironment *env);
	createMM::~createMM();
};